<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <!-- 主表单区域 -->
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="12" >
            <a-form-item label="散货柜编号" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['bulkNo']" disabled="true" placeholder="请输入散货柜编号"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="货柜号" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['containerNo']" disabled="true" placeholder="请输入货柜号"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="12" >
            <a-form-item label="装柜日期" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择装柜日期" disabled="true" v-decorator="['loadingDate']" :trigger-change="true" style="width: 100%"/>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
    <a-col :span="2" style="float:right">
      <a @click="showDetail()">查看详情</a>
    </a-col>
      <!-- 子表单区域 -->
    <a-tabs v-model="activeKey" @change="handleChangeTabs">
      <a-tab-pane tab="物流信息" :key="refKeys[0]" :forceRender="true">
        <j-editable-table
          :ref="refKeys[0]"
          :loading="iostDeliverstatusListTable.loading"
          :columns="iostDeliverstatusListTable.columns"
          :dataSource="iostDeliverstatusListTable.dataSource"
          :disabled="formDisabled"
          :rowNumber="true"
          :rowSelection="true"
          :actionButton="true"/>
      </a-tab-pane>
    </a-tabs>
    <iost-delivery-record-modal ref="recordModalForm" @ok="modalFormOk"/>
  </a-spin>
</template>

<script>

  import pick from 'lodash.pick'
  import { getAction } from '@/api/manage'
  import { FormTypes,getRefPromise } from '@/utils/JEditableTableUtil'
  import { JEditableTableMixin } from '@/mixins/JEditableTableMixin'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'
  import JDate from '@/components/jeecg/JDate'  
  import IostDeliveryRecordModal from './IostDeliveryRecordModal'

  export default {
    name: 'IostDeliverstatusForm',
    mixins: [JEditableTableMixin],
    components: {
      JFormContainer,
      JDate,
      IostDeliveryRecordModal,
    },
    data() {
      return {
        labelCol: {
          xs: { span: 24 },
          sm: { span: 6 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        labelCol2: {
          xs: { span: 24 },
          sm: { span: 3 },
        },
        wrapperCol2: {
          xs: { span: 24 },
          sm: { span: 20 },
        },
        // 新增时子表默认添加几行空数据
        addDefaultRowNum: 1,
        validatorRules: {
        },
        refKeys: ['iostDeliverstatusList', ],
        tableKeys:['iostDeliverstatusList', ],
        activeKey: 'iostDeliverstatusList',
        // 物流信息
        iostDeliverstatusListTable: {
          loading: false,
          dataSource: [],
          columns: [
            {
              title: '地点',
              key: 'location',
              type: FormTypes.input,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
            {
              title: '日期',
              key: 'date',
              type: FormTypes.date,
              width:"200px",
              placeholder: '请输入${title}',
              defaultValue: '',
            },
          ]
        },
        url: {
          add: "/basedata/iostDeliverstatus/add",
          edit: "/basedata/iostDeliverstatus/edit",
          queryById: "/basedata/iostDeliverstatus/queryById",
          iostDeliverstatusList: {
            list: '/basedata/iostDeliverstatus/queryIostDeliverstatusListByMainId'
          },
        }
      }
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：false流程表单 true普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      showDetail()
      {
        let that = this;
        let url = `${window._CONFIG['domianURL']}/basedata/iostDeliveryRecord/queryById`;
        getAction(url,{id:this.model.id}).then((res)=>{
          if(res.success){
            that.$refs.recordModalForm.edit(res.result);
            that.$refs.recordModalForm.disableSubmit = true;
          }
        })
        
      },
      addBefore(){
        this.form.resetFields()
        this.iostDeliverstatusListTable.dataSource=[]
      },
      getAllTable() {
        let values = this.tableKeys.map(key => getRefPromise(this, key))
        return Promise.all(values)
      },
      /** 调用完edit()方法之后会自动调用此方法 */
      editAfter() {
        let fieldval = pick(this.model,'bulkNo','containerNo','loadingDate')
        this.$nextTick(() => {
          this.form.setFieldsValue(fieldval)
        })
        // 加载子表数据
        if (this.model.id) {
          let params = { id: this.model.id }
          this.requestSubTableData(this.url.iostDeliverstatusList.list, params, this.iostDeliverstatusListTable)
        }
      },
      /** 整理成formData */
      classifyIntoFormData(allValues) {
        let main = Object.assign(this.model, allValues.formValue)
        return {
          ...main, // 展开
          iostDeliverstatusListList: allValues.tablesValue[0].values,
        }
      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          })
        }
      },
      validateError(msg){
        this.$message.error(msg)
      },
     popupCallback(row){
       this.form.setFieldsValue(pick(row,'bulkNo','containerNo','loadingDate'))
     },

    }
  }
</script>

<style scoped>
</style>